From 5b1ee1fc4e4606772ab7dce6bbc9011c483072ea Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 01:21:39 +0000
Subject: [PATCH 1123/2232] Inline some Str accessors into the header


---

diff --git a/include/cxx.h b/include/cxx.h
index 3499fec..de614d1 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -57,7 +57,6 @@ private:
 #endif // CXXBRIDGE05_RUST_STRING
 
 #ifndef CXXBRIDGE05_RUST_STR
-#define CXXBRIDGE05_RUST_STR
 class Str final {
 public:
   Str() noexcept;
@@ -320,6 +319,15 @@ struct unsafe_bitcopy_t final {
 constexpr unsafe_bitcopy_t unsafe_bitcopy{};
 #endif // CXXBRIDGE05_RUST_BITCOPY
 
+#ifndef CXXBRIDGE05_RUST_STR
+#define CXXBRIDGE05_RUST_STR
+inline const char *Str::data() const noexcept { return this->ptr; }
+
+inline size_t Str::size() const noexcept { return this->len; }
+
+inline size_t Str::length() const noexcept { return this->len; }
+#endif // CXXBRIDGE05_RUST_STR
+
 #ifndef CXXBRIDGE05_RUST_SLICE
 #define CXXBRIDGE05_RUST_SLICE
 template <typename T>
diff --git a/src/cxx.cc b/src/cxx.cc
index 08ad3ce..5877b35 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -144,12 +144,6 @@ Str::operator std::string() const {
   return std::string(this->data(), this->size());
 }
 
-const char *Str::data() const noexcept { return this->ptr; }
-
-size_t Str::size() const noexcept { return this->len; }
-
-size_t Str::length() const noexcept { return this->len; }
-
 std::ostream &operator<<(std::ostream &os, const Str &s) {
   os.write(s.data(), s.size());
   return os;

